/***********************************************************************
** Copyright (C) Tongwei Video Technology Co.,Ltd. All rights reserved.
** Author       :	Ԭʯά
** Date         : 2010-12-17
** Name         : DDRecordLog.h
** Version      : 1.0
** Description  :
** Modify Record:
***********************************************************************/
#ifndef _DD_RECORD_LOG_H_
#define _DD_RECORD_LOG_H_

typedef struct  _dd_record_log_file_head_info_
{
	unsigned int	headFlag;				//ļͷʶ
	unsigned int	version;				//ļİ汾

	unsigned int	recordChnnNum;			//¼ͨĿ
	unsigned int	recordFileNum;			//¼ļĿ
	
	unsigned int	recordFileLen;			//¼ļС
	unsigned int	recordFileStart;		//¼ļʼλãڣ
	unsigned int	recordFileEnd;			//¼ļĽλãڣ
	
	unsigned int	diskInfoOffset;			//Ϣƫƣÿ¼ļӦһΣ
	unsigned int	diskInfoLen;			//Ϣܳ

	unsigned int	recordFileLogNum;		//Ԥ洢ռдļ¼Ŀ
	unsigned int	recordFileInfoOffset;	//¼ļϢƫƣļ¼ƫƣ
	unsigned int	recordFileInfoLen;		//¼ļϢܳ

	unsigned int	fileLen;				//Ľ

	unsigned int	checkBit;				//Уλ
}DD_RECORD_LOG_FILE_HEAD_INFO;

typedef struct _dd_disk_index_info_
{
	unsigned int	channel;	//ͨ
	unsigned int	flag;		//ǣΪ0XFFFF)
	
	unsigned int	recv[6];	//
}DD_DISK_INDEX_INFO;

typedef struct _dd_file_file_info_
{
	unsigned short		deviceID;		//豸
	unsigned short		cameraID;		//
	unsigned int		channel;		//ͨ
	
	unsigned int		startTime;		//ʼʱ
	unsigned int		endTime;		//ʱ

	unsigned int		checkBit;		//Уλ
}DD_FILE_FILE_INFO;

typedef struct _dd_file_log_info_
{
	unsigned char	bLocked;		//0ʾδ1ʾ
	unsigned char	bUnofficial;	//0ʾʽ¼1ʾʽ¼޸ʱص¼
	unsigned char	enableCard;		//Ƿʹÿ
	unsigned char	recv;			//ֽ

	unsigned int	type;			//¼
	unsigned int	startTime;		//ʼʱ
	unsigned int	endTime;		//ʱ
	unsigned int	size;			//ö¼ݳ

	char			cardNo[32];		//

	unsigned char	recv[8];		//

	unsigned int	checkBit;		//Уλ
}DD_FILE_LOG_INFO;

typedef struct _dd_date_info_
{
	DD_DATE		date;						//Ϣ
	std::list<unsigned short> *pFileList;	//飨ͨ
}DD_DATE_INFO, *P_DD_DATE_INFO;

const unsigned int	MAX_RECORD_LOG_NUM = 256;

class CDDRecordLog
{
public:
	CDDRecordLog();
	~CDDRecordLog();

	//һµݿļ
	static bool CreateLogFile(const char *pFilePath, unsigned int fileNum, unsigned char videoInputNum, unsigned int maxLogNum);

	//ʼͷʼһеݿļ
	bool Initial(unsigned char diskIndex, const char *pFilePath = NULL);
	void Quit();
	bool CreateDateList();

	//
	unsigned int WriteLogStart(unsigned int type, unsigned int startTime, bool bCardNo = false, const char *pCardNo = NULL);
	unsigned int WriteLogEnd(unsigned int type, unsigned int endTime, unsigned int size);

	//һЩѯķ
	unsigned int GetDateList(std::list<DD_DATE> & list);
	unsigned int GetRecordLog(const std::list<unsigned short> & chnn, unsigned int startTime, unsigned int endTime, \
		unsigned int type, std::list<DD_RECORD_LOG> *pLogList);

	//
	unsigned int Lock(const std::list<DD_RECORD_LOG> &logList);
	unsigned int UnLock(const std::list<DD_RECORD_LOG> &logList);
protected:
private:
};
