
#ifndef _DISPLAY_LAYOUT_SDK_H_
#define _DISPLAY_LAYOUT_SDK_H_

#include "DisplayDefine.h"

#ifdef WIN32

#define CALL_METHOD __stdcall

#ifdef LAYOUT_SDK_EXPORTS
#define LAYOUT_API __declspec(dllexport)
#else
//#define LAYOUT_API __declspec(dllimport)
#define LAYOUT_API
#endif

#else

#define CALL_METHOD
#define LAYOUT_API
#endif

enum
{
	LAYOUT_RET_SUCCESS,
	LAYOUT_RET_CHANNEL_BINDED,
	LAYOUT_RET_PORT_BINDED,
	LAYOUT_RET_PORT_EXCEED,
};

#ifdef __cplusplus
extern "C"
{
#endif

//maxPortNum,õķָлĸ
LAYOUT_API bool CALL_METHOD LAYOUT_Init(unsigned short maxPortNum);
LAYOUT_API void CALL_METHOD LAYOUT_Cleanup();

//ʾС
LAYOUT_API void CALL_METHOD LAYOUT_SetDisplayArea(unsigned short x, unsigned short y, unsigned short width, unsigned short height);

//ñ׼ķָ,bAutoNextʾϴָͬģʽʱǷҪһҳ
LAYOUT_API void CALL_METHOD LAYOUT_SetSplitMode(unsigned int splitMode, bool bAutoNext, unsigned int firstVisiblePort=0);

//ϲʾڣɾֲ󴰿
LAYOUT_API void CALL_METHOD LAYOUT_CombinePort(unsigned short startPort, unsigned short horizSpan, unsigned short vertSpan);

//ݵλõõ򣬷صţûеκ򣬷-1
LAYOUT_API int CALL_METHOD LAYOUT_GetHitPort(unsigned short x, unsigned short y, DISPLAY_PORT *pHitPort);

//豸ָͨʾ
LAYOUT_API int CALL_METHOD LAYOUT_BindPortVideoStream(unsigned short portIndex, int deviceID, short channel, short streamType);

//ûлͨ
LAYOUT_API int CALL_METHOD LAYOUT_BindPIPVideoStream(LAYOUT_PIP_POSITION pipPosition, int deviceID, short channel, short streamType);

//ĳ豸ͨ
LAYOUT_API void CALL_METHOD LAYOUT_UnbindVideoStream(int deviceID, short channel, short streamType);

//ĳʾڣportIndexΪ0xffffʾ,л
LAYOUT_API void CALL_METHOD LAYOUT_UnbindPort(unsigned short portIndex);

//ĳл
LAYOUT_API void CALL_METHOD LAYOUT_UnbindPIPPort(LAYOUT_PIP_POSITION pipPosition);

//صǰʾϢ
LAYOUT_API int CALL_METHOD LAYOUT_GetLayoutInfo(DISPLAY_PORT *pDisplayPort, int portNum);

#ifdef __cplusplus
};
#endif

#endif

