/***********************************************************************
** Copyright (C) Tongwei Video Technology Co.,Ltd. All rights reserved.
** Author       : YSW
** Date         : 2010-11-19
** Name         : dvrdvsconfig.h
** Version      : 1.0
** Description  :	DVR/DVSصһЩ
** Modify Record:
1:
***********************************************************************/
#ifndef __DVR_DVS_CONFIG_H__
#define __DVR_DVS_CONFIG_H__

#include "dvrdvstypedef.h"
//////////////////////////////////////////////////////////////////////////
const unsigned int DD_MAX_CAMERA_NUM	= 128;
const unsigned int DD_MAX_CAMERA_NUM_BYTE_LEN	= DD_MAX_CAMERA_NUM/8;
const unsigned int DD_MAX_SERIAL_NUMBER_LEN = 64;
const unsigned int DD_MAX_VERSION_BUF_LEN = 64;

const unsigned int	DD_MAX_NAME_LEN		= 64;	
const unsigned int	DD_MAX_NAME_BUF_LEN	= (DD_MAX_NAME_LEN * 2) + 4;

const unsigned int	DD_MAX_CAMERA_NAME_LEN		= 64;	
const unsigned int	DD_MAX_CAMERA_NAME_BUF_LEN	= (DD_MAX_CAMERA_NAME_LEN * 2) + 4;

const unsigned int DD_MAX_URL_LEN		= 256;
const unsigned int DD_MAX_URL_BUF_LEN	= DD_MAX_URL_LEN + 4;

const unsigned int DD_MAX_COLOR_CFG_NUM = 3;

const unsigned int DD_MAX_TEXT_LEN		= 64;
const unsigned int	DD_MAX_TEXT_BUF_LEN	= (DD_MAX_TEXT_LEN * 2) + 4;

const unsigned int DD_MAX_VIDEO_COVER_NUM = 3;

const unsigned int DD_MAX_USER_NAME_LEN	= 64;
const unsigned int DD_MAX_USER_NAME_BUF_LEN = (DD_MAX_USER_NAME_LEN * 2) + 4;
const unsigned int DD_MAX_PASSWORD_LEN		= 128;
const unsigned int DD_MAX_PASSWORD_BUF_LEN	= DD_MAX_PASSWORD_LEN + 4;

const unsigned int DD_MAX_PPPOE_ACCOUNT_LEN		= 128;
const unsigned int DD_MAX_PPPOE_ACCOUNT_BUF_LEN	= DD_MAX_PPPOE_ACCOUNT_LEN + 4;

const unsigned int DD_MAX_DDNS_ACCOUNT_LEN			= 128;
const unsigned int DD_MAX_DDNS_ACCOUNT_BUF_LEN		= DD_MAX_DDNS_ACCOUNT_LEN + 4;

const unsigned int DD_MAX_EMAIL_RECEIVE_ADDR_NUM = 3;

const unsigned int DD_MAX_MOTION_AREA_WIDTH_NUM = 1920/16;
const unsigned int DD_MAX_MOTION_AREA_HIGHT_NUM = (1080/16+3)&(~3);

const unsigned int DD_MAX_PRESET_NUM	= 128;
const unsigned int DD_MAX_CRUISE_NUM	= 32;
const unsigned int DD_MAX_TRACK_NUM	= 1;
const unsigned int DD_MAX_ACCOUNT_NUM	= 64;
const unsigned int DD_MAX_BUF_SIZE = 512*1024;

const unsigned int DD_MAX_SUPPORT_RESOLUTION = 7;
const unsigned int DD_MAX_FACE_INFO_GROUPS = 16;
const unsigned int DD_MAX_FACE_INFO_IMG = 5;
//////////////////////////////////////////////////////////////////////////

//豸ϢݣãҲڲѯ豸Ϣ
typedef struct _dd_device_info_
{
	unsigned int	iSize;		//ṹ峤

	unsigned int	deviceID;	//豸ID(0~255)
	char			deviceNo[DD_MAX_SERIAL_NUMBER_LEN];		//豸кţʹĸ
	char			deviceName [DD_MAX_NAME_LEN];			//豸ƣע⿼˫ַֽ

	//Ϊֻ
	//version
	char			firmwareVersion [DD_MAX_VERSION_BUF_LEN];
	char			firmwareBuildDate [DD_MAX_VERSION_BUF_LEN];
	char			hardwareVersion [DD_MAX_VERSION_BUF_LEN];
	char			kernelVersion [DD_MAX_VERSION_BUF_LEN];
	char			mcuVersion [DD_MAX_VERSION_BUF_LEN];

	//ӿڲ
	unsigned char	audioNum;
	unsigned char	localVideoInNum;
	unsigned char	netVideoInNum;
	unsigned char	sensorInNum;
	unsigned char	relayOutNum;

	unsigned char	rs232Num;
	unsigned char	rs485Num;
	unsigned char	networkPortNum;
	unsigned char	diskCtrlNum;
	unsigned char	DiskNum;
	unsigned char	vgaNum;
	unsigned char	usbNum;
}DD_DEVICE_INFO;

typedef struct _dd_basic_config_
{
	unsigned int iSize;				//ṹ峤

	unsigned int videoFormat;			//ƵʽȡֵοDD_VIDEO_FORMAT

	unsigned int videoOut;				//Ƶ豸
	unsigned int videoOutResolution;	//ֱʣȡֵοDD_VGA_RESOLUTION
	unsigned int VGARefresh;			//VGAˢ
	unsigned int screensaver;			//ʱ䣨ʾ

	unsigned int deviceLanguage;		//ϵͳ
	unsigned int passwordCheck;		//Ƿ

	unsigned int RecycleRecord;		//Ƿ¼

	//ΪһЩֻ
	unsigned int videoFormatMask;			//ֵ֧Ƶʽ루ֻȡֵΪDD_VIDEO_FORMATݵ
	unsigned int videoOutMask;				//ֵ֧Ƶ豸루ֻ
	unsigned int videoOutResolutionMask;	//ֵ֧Ƶ豸ֱ루ֻȡֵΪDD_VGA_RESOLUTIONݵ
	unsigned int languageMask;				//ֵ֧루ֻ
}DD_BASIC_CONFIG;

typedef struct _dd_date_time_config
{
	unsigned int iSize;		//ṹ峤

	unsigned char dateFormat;	//ڸʽȡֵΪDD_DATE_MODE
	unsigned char timeFormat;	//ʱʽ1212Сʱƣ2424Сʱ
	unsigned char timeZone;		//ʱȡֵΪDD_TIME_ZOME_NAME

	unsigned char enableNTP;	//ǷNTPͬ
	unsigned short	ntpPort;	//NTP˿
    unsigned char   daylightSwitch;//only n9000
    unsigned char	recv;
	char	ntpServerAddr[DD_MAX_URL_BUF_LEN];	//NTPַ
}DD_DATE_TIME_CONFIG;

typedef struct _dd_daylight_info_
{
	unsigned char InMonth;		//ڼ½DST
	unsigned char InMday;		//ڼսDSTڷʽЧ
	unsigned char OutMonth;		//ڼ³DST
	unsigned char OutMday;		//ڼճDSTڷʽЧ

	unsigned char InWeekIndex;	//ڼܽDSTܷʽЧ
	unsigned char InWday;		//ڼDSTܷʽЧ
	unsigned char OutWeekIndex;	//ڼܳDSTܷʽЧ
	unsigned char OutWday;		//ڼDSTܷʽЧ

	unsigned short InYear;		//DSTݣãǷڴˣպÿԶṹ壬Ա
	unsigned short OutYear;		//DSTݣãǷڴˣպÿԶṹ壬Ա

	unsigned short enable;		//Ƿʱ
	unsigned short type;		//ʱ÷ʽܻڷʽ

	unsigned int InSecond;		//DSTһڵƫƣ086399תʱ
	unsigned int OutSecond;	//DSTһڵƫƣ086399תʱ

	unsigned int offSet;		//ʱƫ086399롣

}DD_DAYLIGHT_INFO;

typedef struct _dd_live_video_group_
{
	unsigned short	holdTime;	//ͣʱ䣨룩,ʾЧ
	unsigned short	channelNum;	//ЧͨĿֻ

	unsigned int	splitMode;	//ָģʽȡֵοDD_VIEW_SPLIT_MODE

	//Ӧͨţ±ͨţԪֵ
	//0xffʾͨЧ
	unsigned char	channel [DD_MAX_CAMERA_NUM]; //Ӧͨ
}DD_LIVE_VIDEO_GROUP;

typedef struct _dd_live_audio_group_
{
	unsigned short holdTime;		//ͣʱ䣨룩,ʾЧ
	unsigned char volume;			//0~100)
	unsigned char channel;			//ͨ
}DD_LIVE_AUDIO_GROUP;

typedef struct _dd_live_display_
{
	unsigned int iSize;			//ṹ峤

	unsigned int showTime;			//Ƿʾϵͳʱ
	unsigned int showNetwork;		//Ƿʾ״̬
	unsigned int showHDD;			//ǷʾӲϢ
	unsigned int showUSB;			//Ƿʾƶ洢Ϣ

	unsigned short	alarmInNum;		//Ŀֻ
	unsigned short	alarmOutNum;	//Ŀֻ
	unsigned int	showAlarmIn;	//ǷʾϢ	
	unsigned int	showAlarmOut;	//ǷʾϢ

	unsigned int cameraNum;		//ЧͨĿֻ
	unsigned char showCameraName [DD_MAX_CAMERA_NUM];	//Ƿʾͨ
	unsigned char showRecordStatus [DD_MAX_CAMERA_NUM];	//Ƿʾ¼״̬
}DD_LIVE_DISPLAY;

typedef struct _dd_channel_config_
{
	unsigned int iSize;						//ṹ峤

	unsigned int hide;							//Ƿͨ
	char	name [DD_MAX_CAMERA_NAME_BUF_LEN];	//ͨ
}DD_CHANNEL_CONFIG;

typedef struct _dd_video_color_
{
	unsigned int	startTime;		//ɫʶӦĿʼʱ䣨һʱ䣩

	unsigned char	brightness;		//
	unsigned char	hue;			//ɫ
	unsigned char	saturation;		//Ͷ
	unsigned char	contrast;		//Աȶ
}DD_VIDEO_COLOR;

typedef struct _dd_video_color_config_
{
	unsigned int	iSize;			//ṹ峤

	unsigned int	usedNum;		//ʹõķĿĬΪһ
	DD_VIDEO_COLOR	videoColor[DD_MAX_COLOR_CFG_NUM];	//ɫʷ
}DD_VIDEO_COLOR_CONFIG;

typedef struct _dd_position_
{
	unsigned short x;		//
	unsigned short y;		//
}DD_POSITION;

typedef struct _dd_area_
{
	unsigned short x;		//
	unsigned short y;		//

	unsigned short cx;		//
	unsigned short cy;		//߶
}DD_AREA;

typedef struct _dd_video_osd_config_
{
	unsigned int iSize;					//ṹ峤

	unsigned char enableCameraName;			//ͨ
	unsigned char enableTimeStamp;			//ʱ
	unsigned char enableTimeStampWithWeek;	//ʱϼ
	unsigned char enableDefineText;			//Զı

	DD_POSITION cameraName;					//ͨƵλ
	DD_POSITION timeStamp;					//ʱλ
	DD_POSITION defineText;					//Զıλ
    char cameraNameText [DD_MAX_CAMERA_NAME_LEN];		//ͨ
    char text [DD_MAX_TEXT_LEN];		//Զı
    char timeFormat;                    //ʱʽ
    char recv[3];

	struct  
	{
		unsigned int	enable;				//򸲸ǷЧ
		DD_AREA			area;				//
	}cover[DD_MAX_VIDEO_COVER_NUM];			//ǵ
}DD_VIDEO_OSD_CONFIG;

typedef struct _dd_encode_config_
{
	unsigned int iSize;		//ṹ峤

	unsigned short resolution;	//ֱʣȡֵοDD_VIDEO_SIZE
	unsigned short rate;		//֡
	unsigned short encodeType;	//ͣȡֵοDD_VIDEO_ENCODE_MODE
	unsigned short quality;		//ʣȡֵοDD_IMAGE_QUALITY

	unsigned short minBitrate;	//
	unsigned short maxBitrate;	//
}DD_ENCODE_CONFIG;

typedef struct _dd_encode_config_n9000_
{
	unsigned int iSize;		//ṹ峤

	unsigned int resolution;	//ֱʣȡֵοDD_VIDEO_SIZE
	unsigned short rate;		//֡
	unsigned short encodeType;	//ͣȡֵοDD_VIDEO_ENCODE_MODE
	unsigned short quality;		//ʣȡֵοDD_IMAGE_QUALITY

	unsigned short minBitrate;	//
	unsigned short maxBitrate;	//
    unsigned short encodeFormat;  //264or265 DD_VIDEO_ENCODE_FORMAT
}DD_ENCODE_CONFIG_N9000;


typedef struct _dd_encode_config_ex_
{
    unsigned int iSize;		//ṹ峤

    unsigned int resolution;	//ֱʣȡֵοDD_VIDEO_SIZE
    unsigned short rate;		//֡
    unsigned short encodeType;	//ͣȡֵοDD_VIDEO_ENCODE_MODE
    unsigned short quality;		//ʣȡֵοDD_IMAGE_QUALITY

    unsigned short minBitrate;	//
    unsigned short maxBitrate;	//
    unsigned short bitrate; //
    unsigned short encodeFormat;  //264or265 DD_VIDEO_ENCODE_FORMAT
    char recv[14];			//ֽ
}DD_ENCODE_CONFIG_EX;

typedef struct _dd_encode_config_n9000_ex_
{
    unsigned int iSize;		//ṹ峤

    unsigned int resolution;	//ֱʣȡֵοDD_VIDEO_SIZE
    unsigned short rate;		//֡
    unsigned short encodeType;	//ͣȡֵοDD_VIDEO_ENCODE_MODE
    unsigned short quality;		//ʣȡֵοDD_IMAGE_QUALITY

    unsigned short minBitrate;	//
    unsigned short maxBitrate;	//
    unsigned short bitrateRange[16]; //ֵ֧
}DD_ENCODE_CONFIG_N9000_Ex;



typedef struct _dd_encode_config_support_
{
	DD_ENCODE_CONFIG encodeConfig[DD_MAX_SUPPORT_RESOLUTION];
	unsigned int num;
}DD_ENCODE_CONFIG_SUPPORT;

typedef struct _dd_record_config_
{
	unsigned int iSize;			//ṹ峤

	unsigned char bOnlyVideo;		//¼ƵƵ
	unsigned char bWithAudio;		//¼Ƶ¼ƵĻϣ
	unsigned char bindAudioChannel;	//ӦƵͨһƵͨһ£
	unsigned char bRedundancy;		//Ƿ¼

	unsigned short preAlarmTime;	//ǰ¼ʱ
	unsigned short postAlarmTime;	//¼ʱ

	unsigned short expired;			//¼ʱ
	unsigned short recv;			//ֽ
}DD_RECORD_CONFIG;

//˽ṹΪֻݣڲѯ豸ֲ֧
typedef struct _dd_record_config_mask_
{
	unsigned int iSize;

	unsigned char bindAudioChannel;	//Ƿ֧Ƶͨ
	unsigned char bRedundancy;		//Ƿ֧¼
	unsigned char recv1;
	unsigned char recv2;

	unsigned short minPreAlarmTime;	//Сǰ¼ʱ
	unsigned short maxPreAlarmTime;	//ǰ¼ʱ

	unsigned short minPostAlarmTime;	//С¼ʱ
	unsigned short maxPostAlarmTime;	//󾯺¼ʱ

	unsigned short minExpired;		//С¼ݹʱ
	unsigned short maxExpired;		//¼ݹʱ
}DD_RECORD_CONFIG_MASK;

//ų̽ṹ2424Сʱunsigned long longÿһλÿһӵ״̬
typedef struct _dd_date_schedule_
{
	unsigned long long hour [24];
}DD_DATE_SCHEDULE;

//ų̽ṹ7ʾÿ7ų
typedef struct _dd_week_schedule_
{
	DD_DATE_SCHEDULE week[7];
}DD_WEEK_SCHEDULE;

typedef struct _dd_network_ip_config_
{
	unsigned int iSize;			//ṹ峤

	unsigned int	useDHCP;		//Ƿʹöַ̬

	unsigned int	IP;				//ַ
	unsigned int	subnetMask;		//
	unsigned int	gateway;		//

	unsigned int	preferredDNS;	//ַ
	unsigned int	alternateDNS;	//ַ

	unsigned int	usePPPoE;		//ǷʹPPPoE
	char account[DD_MAX_PPPOE_ACCOUNT_BUF_LEN];	//PPPoEʺ
	char password[DD_MAX_PASSWORD_BUF_LEN];		//PPPoE
}DD_NETWORK_IP_CONFIG;

typedef struct _dd_network_advance_config_
{
	unsigned int iSize;			//ṹ峤

	unsigned char bMessagePort;		//Ƿ֧Ϣ˿ڣֻ
	unsigned char bAlarmPort;		//Ƿֱ֧˿ڣֻ
	unsigned char bMultiCastIP;		//Ƿֶ֧ಥַֻ
	unsigned char bMTUByteNum;		//Ƿ֧MTUֻֽ

	unsigned short httpPort;		//HTTP˿
	unsigned short datePort;		//ݶ˿
	unsigned short messagePort;		//Ϣ˿
	unsigned short alarmPort;		//˿

	unsigned short maxOnlineUserNum;	//ֵ֧ûĿֻ
	unsigned short OnlineUserNum;		//ûĿ

	unsigned int multiCastIP;		//ಥַ
	unsigned int mtuByteNum;		//MTUֽ
}DD_NETWORK_ADVANCE_CONFIG;

typedef struct _dd_ddns_config_
{
	unsigned int iSize;			//ṹ峤

	unsigned short enable;			//ǷDDNS
	unsigned short interval;		//ϱ

	unsigned int useDDNSServer;	//ʹõDDNSͻߵַ

	unsigned int userHostDomain;	//Ƿ

	char userName [DD_MAX_DDNS_ACCOUNT_BUF_LEN];	//DDNSʺ
	char password [DD_MAX_PASSWORD_BUF_LEN];		//DDNS

	char hostDomain [DD_MAX_URL_BUF_LEN];			//ӦĳЭ飬ָ
}DD_DDNS_CONFIG;

typedef struct _dd_ddns_server_info 
{
	unsigned char  DDNSID; /////ӦķID   ID0ӦķƲЧ
	unsigned char  supportproperty;//ֵ֧ĳûԵMASK,NCFG_ENUM_DDNS_SUPPORT_PROPERTY
	unsigned char  noused[2];
	char           DDNSServerName[64];  ////DDNSĵַ
}DD_DDNS_SERVER_INFO;

typedef struct _dd_smtp_config_
{
	unsigned int iSize;				//ṹ峤

	unsigned short port;				//ʼ˿
	unsigned short enableSSL;			//ǷSSL

	char server [DD_MAX_URL_BUF_LEN];	//ͷַ

	char sendAddress [DD_MAX_URL_BUF_LEN];	//ʼַ
	char password [DD_MAX_PASSWORD_BUF_LEN];//ʺ

	unsigned int enableRecvAddrNum;		//õĽյַĿֻ
	char receiveAddress [DD_MAX_EMAIL_RECEIVE_ADDR_NUM][DD_MAX_URL_BUF_LEN];//յַб
}DD_SMTP_CONFIG;

typedef struct _dd_auto_report_
{
	unsigned int   bUse;			//ǷԶϱעṦ
	char			host[256];		//עƽַ̨
	unsigned int	dwPort;			//עƽ̨˿
	unsigned int	ID;				//עID
}DD_AUTO_REPORT;
typedef struct _dd_account_config_
{
	unsigned int iSize;			//ṹ峤

	unsigned int enable;			//Ƿøʺ
	unsigned int bindMAC;			//Ƿַ
	unsigned int group;			//Ⱥ飬ȡֵοDD_USER_GROUP

	char MAC [8];					//󶨵ַ
	char name [DD_MAX_USER_NAME_BUF_LEN];	//û
	char password [DD_MAX_PASSWORD_BUF_LEN];//ʺ

	//Ȩ޵
	unsigned char logSearch;		//־Ȩ
	unsigned char systemSetup;		//ϵͳ
	unsigned char fileManagement;	//ļ
	unsigned char diskManagement;	//̹
	unsigned char remoteLogin;		//Զ̵
	unsigned char twoWayAudio;		//Խ
	unsigned char systemMaintain;	//ϵͳά
	unsigned char OnlineUserManagement;	//û
	unsigned char shutdown;			//ػ
	unsigned char alarmOutCtrl;		//
	unsigned char netAlarm;			//籨
	unsigned char netSerialCtrl;	//紮ڿ
	
	unsigned char authLive;
	unsigned char authRecord;
	unsigned char authPlayback;
	unsigned char authBackup;
	unsigned char authPTZ;
	unsigned char netAuthView;
	unsigned char netauthRecord;
	unsigned char netauthPlayback;
	unsigned char netauthBackup;
	unsigned char netauthPTZ;
	unsigned char recv[2];

	unsigned char authLiveCH [DD_MAX_CAMERA_NUM_BYTE_LEN];          //ֳԤͨ
	unsigned char authRecordCH [DD_MAX_CAMERA_NUM_BYTE_LEN];		//ֶ¼
	unsigned char authPlaybackCH [DD_MAX_CAMERA_NUM_BYTE_LEN];		//ؼط
	unsigned char authBackupCH [DD_MAX_CAMERA_NUM_BYTE_LEN];		//ر
	unsigned char authPTZCH [DD_MAX_CAMERA_NUM_BYTE_LEN];			//̨

	unsigned char netAuthViewCH [DD_MAX_CAMERA_NUM_BYTE_LEN];		//ԶֳԤ
	unsigned char netAuthRecordCH [DD_MAX_CAMERA_NUM_BYTE_LEN];		//Զֶ¼
	unsigned char netAuthPlaybackCH [DD_MAX_CAMERA_NUM_BYTE_LEN];	//Զ̻ط
	unsigned char netAuthBackupCH [DD_MAX_CAMERA_NUM_BYTE_LEN];		//Զ̱
	unsigned char netAuthPTZCH [DD_MAX_CAMERA_NUM_BYTE_LEN];		//Զ̨
}DD_ACCOUNT_CONFIG;

typedef struct _dd_trigger_alarm_out_
{
	unsigned char toBuzzer;					//
	unsigned char ShowFullScreen;			//汨ͨţ0xffΪ
	unsigned char sendEmail;				//ʼ
	unsigned char toUploadToAlarmCentre;	//ϴ

	unsigned int toAlarmOut;				//λӦ豸
}DD_TRIGGER_ALARM_OUT;

typedef struct _dd_trigger_record_
{
	unsigned char snapCH [DD_MAX_CAMERA_NUM_BYTE_LEN];		//ץͼ
	unsigned char recordCH [DD_MAX_CAMERA_NUM_BYTE_LEN];	//¼
}DD_TRIGGER_RECORD;

typedef struct _dd_trigger_ptz_
{
	unsigned char toPTZType;	//ͣԤõ㡢Ѳߡ켣DD_PTZ_TYPE

	unsigned char toIndex;		//ģԤõ㡢Ѳߡ켣
	unsigned char backIndex;	//ķأԤõ㡢Ѳߡ켣
	unsigned char recv;			//ֽ
}DD_TRIGGER_PTZ;

typedef struct _dd_sensor_config_
{
	unsigned int iSize;		//ṹ峤

	unsigned char	enable;		//Ƿ
	unsigned char	bNO;		//豸ͣ߳
	unsigned short	holdTime;	//ӳʱ

	char name [DD_MAX_NAME_BUF_LEN];	//豸
}DD_SENSOR_CONFIG;

typedef struct _dd_motion_area_
{
	unsigned int sensitivity;		//ȣ07ԽԽ

	unsigned short widthNum;		//ĺդĿ
	unsigned short heightNum;		//դĿ

	//դݣ1920x1080ÿ8X8С
	unsigned char area [DD_MAX_MOTION_AREA_HIGHT_NUM][DD_MAX_MOTION_AREA_WIDTH_NUM];
}DD_MOTION_AREA;

typedef struct _dd_motion_config_
{
	unsigned int iSize;		//ṹ峤

	unsigned char	enable;		//Ƿƶ
	unsigned char	recv;		//ֽ

	unsigned short	holdTime;	//ӳʱ

	DD_MOTION_AREA	area;		//
}DD_MOTION_CONFIG;

typedef struct _dd_buzzer_config_
{
	unsigned char enable;		//ÿ
	unsigned char recv;			//ֽ

	unsigned short holdTime;	//ӳʱ
}DD_BUZZER_CONFIG;

typedef struct _dd_relay_config_
{
	unsigned char enable;		//豸ÿ
	unsigned char recv;			//ֽ

	unsigned short holdTime;	//ӳʱ

	char name [DD_MAX_NAME_BUF_LEN];	//豸
}DD_RELAY_CONFIG;

typedef struct _dd_serial_config_
{
	unsigned int baudRate;			//
	unsigned int dataBit;			//λ
	unsigned int stopBit;			//ֹͣλ
	unsigned int parity;			//żУλ
	unsigned int dataFlowControl;	//
}DD_SERIAL_CONFIG;

typedef struct _dd_ptz_config_
{
	unsigned int iSize;		//ṹ峤

	unsigned char enable;		//Ƿ̨
	unsigned char address;		//ַ
	unsigned char recv1;		//ֽ
	unsigned char recv2;		//ֽ

	unsigned int protocol;		//Э

	DD_SERIAL_CONFIG serial;	//
}DD_PTZ_CONFIG;

typedef struct _dd_ptz_protocol_info 
{
	unsigned int  protocolID;		//ӦЭID
	unsigned int  protocolProperty;//ֵ֧ĳID֮ԵMASK,Ƿֹ֧켣
	char           ProtocolName[64];//Э
}DD_PTZ_PROTOCOL_INFO;

typedef struct _dd_ptz_preset_config_
{
	unsigned int iSize;		//ṹ峤

	//Ԥõ
	unsigned char enablePreset [DD_MAX_PRESET_NUM];
}DD_PTZ_PRESET_CONFIG;

//////////////////////////////////////////////////////////////////////////
typedef struct _dd_config_item_head_
{
	unsigned short	itemID;		//ID
	unsigned short	num;		//ԪĿٸͨÿͨӦһԪ
	unsigned short	subLen;		//ÿԪصĳ
	unsigned short recv;
	unsigned int	len;		//ܳ
}DD_CONFIG_ITEM_HEAD;


typedef struct _dd_config_block_head_
{
	unsigned int	biSize;		//ṹ峤
	unsigned int	ItemNum;	//ԪĿ
	unsigned int	netcfgver;	//ǰİ汾ţ豸˹̶DD_CONFIG_VERSIONͻ˸Ҫ̬ж
}DD_CONFIG_BLOCK_HEAD;

typedef struct _dd_config_item_head_ex_
{
	DD_CONFIG_ITEM_HEAD		item_head;
	unsigned int			start_pos;		//ļƫ
}DD_CONFIG_ITEM_HEAD_EX;		

typedef struct _dd_config_block_info_
{
	DD_CONFIG_ITEM_HEAD_EX	itemHead;
	unsigned int			off;			//ƫ
}DD_CONFIG_BLOCK_INFO;

typedef struct _alarm_status
{
    unsigned int iSize;					//ṹ峤
    int chanl;	//ͨͨ޹صı-1 ͨصͨio֮ıǸ
    unsigned int alarmType;	//¼ NET_SDK_N9000_ALARM_TYPE

}DD_ALARM_STATUS_INFO;

typedef struct _alarm_status_ex
{
	unsigned int iSize;					//ṹ峤
	int index;	//ͨͨ޹صı-1 ͨصͨio֮ıǸ
	unsigned int alarmType;	//¼ NET_SDK_N9000_ALARM_TYPE_RAID_SUBHEALTH, //ǽ NET_SDK_N9000_ALARM_TYPE_RAID_UNAVAILABLE, //в
	char alarmNode[32];
	char	recv[32];		//ֽ

}DD_ALARM_STATUS_INFO_Ex;

typedef struct _network_platform
{
	//N9000ֹ֧ƽ̨ƽ̨ipcɺԹ
	unsigned int CurrentPlat;	//ǰƽ̨ĬΪ1ʾƽ̨2ʾ

	//ƽ̨
	unsigned int Switcher;	//1ʾã0ʾδ
	unsigned int Port;			//˿
	unsigned int ReportId;	//豸ID
	char szAddress[16];			//ipַ

	//ƽ̨ipcʹãN9000ʹ
	unsigned int SwitchGB;	//1ʾã0ʾδ
	unsigned int PortGB;		//˿
	unsigned int uLocalPort;	//ض˿
	char szRelm[16];				//sip
	char szAddressGB[16];	//ַ
	char szUserName[16];		//û
	char szPassword[16];		//
	char szDeviceIdGB[32];	//豸ID
	char szServerIdGB[32];	//sipID
}DD_NETWORK_PLATFORM;

typedef struct _dd_smart_vfd_config_
{
	unsigned int iSize;					   //ṹ峤

	unsigned char  enableFaceDetect;        //Ƿ
	unsigned char  enableSaveFacePicture;   //Ƿ񱣴ͼƬ
	unsigned short enableSaveSourcePicture; //Ƿ񱣴ԴͼƬ
	unsigned int   holdTime;                //ʱ
	DD_POSITION    startPoint;              //εϵϢ
	DD_POSITION    endPoint;                //εµϢ
	unsigned int   pushModeType;            //ץģʽ0Զģʽظץģ 1Թ̶ʱץĵģʽ
	unsigned int   intervalTime;            //ץĵļڣλ룬ץģʽΪ1Ч
}DD_SMART_VFD_CONFIG;

//////////////////////////////////////////////////////////////////////////
const unsigned int		DD_CONFIG_VERSION	= 20101123;
const unsigned int	DD_CONFIG_ITEM_FOR_SDK_DEFINE  = 0xf000; //ﶨsdkڲʹõ ʹ÷ʽDD_CONFIG_ITEM_FOR_SDK_DEFINE+DD_CONFIG_ITEM_ID//вİ汾ϢڲϢֶʹ֮ɲͬṹ
typedef enum dd_config_item_id
{
	DD_CONFIG_ITEM_SYSTEM_BASE=0x0100,
	DD_CONFIG_ITEM_DEVICE_INFO,				//DD_DEVICE_INFO
	DD_CONFIG_ITEM_SYSTEM_BASIC,			//DD_BASIC_CONFIG
	DD_CONFIG_ITEM_DATE_TIME,				//DD_DATE_TIME_CONFIG
	DD_CONFIG_ITEM_DAYLIGHT_INFO,			//DD_DAYLIGHT_INFO
	DD_CONFIG_ITEM_SYSTEM_END,

	DD_CONFIG_ITEM_LIVE_BASE=0x0200,
	DD_CONFIG_ITEM_LIVE_MAIN_CAMERA,		//DD_LIVE_VIDEO_GROUP * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_LIVE_SPOT_CAMERA,		//DD_LIVE_VIDEO_GROUP * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_LIVE_AUDIO,				//DD_LIVE_AUDIO_GROUP * AUDIO_INPUT_NUM
	DD_CONFIG_ITEM_LIVE_DISPLAY,			//DD_LIVE_DISPLAY
	DD_CONFIG_ITEM_LIVE_END,

	DD_CONFIG_ITEM_CHNN_BASE=0x0300,
	DD_CONFIG_ITEM_CHNN_CONFIG,				//DD_CHANNEL_CONFIG * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_VIDEO_COLOR,				//DD_VIDEO_COLOR_CONFIG * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_VIDEO_OSD,				//DD_VIDEO_OSD_CONFIG * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_CHNN_END,

	DD_CONFIG_ITEM_ENCODE_BASE=0x0400,
	DD_CONFIG_ITEM_ENCODE_MASK_MAJOR,		//DD_ENCODE_CONFIG_SUPPORT
	DD_CONFIG_ITEM_ENCODE_MASK_MINOR,		//DD_ENCODE_CONFIG_SUPPORT
	DD_CONFIG_ITEM_ENCODE_SCHEDULE,			//DD_ENCODE_CONFIG * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_ENCODE_ALARM,			//DD_ENCODE_CONFIG * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_ENCODE_NETWORK,			//DD_ENCODE_CONFIG * VIDEO_INPUT_NUM
    DD_CONFIG_ITEM_ENCODE_SCHEDULE_EX,			//DD_ENCODE_CONFIG_EX * VIDEO_INPUT_NUM
    DD_CONFIG_ITEM_ENCODE_NETWORK_EX,			//DD_ENCODE_CONFIG_EX * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_ENCODE_END,

	DD_CONFIG_ITEM_RECORD_BASE=0x0500,
	DD_CONFIG_ITEM_RECORD_MASK,				//DD_RECORD_CONFIG_MASK
	DD_CONFIG_ITEM_RECORD_SETUP,			//DD_RECORD_CONFIG * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_RECORD_SCHEDULE_SCHEDULE,//DD_WEEK_SCHEDULE * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_RECORD_SCHEDULE_MOTION,	//DD_WEEK_SCHEDULE * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_RECORD_SCHEDULE_SENSOR,	//DD_WEEK_SCHEDULE * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_RECORD_END,

	DD_CONFIG_ITEM_NETWORK_BASE=0x0600,
	DD_CONFIG_ITEM_NETWORK_IP,				//DD_NETWORK_IP_CONFIG
	DD_CONFIG_ITEM_NETWORK_ADVANCE,			//DD_NETWORK_ADVANCE_CONFIG
	DD_CONFIG_ITEM_NETWORK_DDNS,			//DD_DDNS_CONFIG
	DD_CONFIG_ITEM_DDNS_SERVER_INFO,		//DD_DDNS_SERVER_INFO
	DD_CONFIG_ITEM_NETWORK_SMTP,			//DD_SMTP_CONFIG
//2012-3-15DVRעĹ
	DD_CONFIG_ITEM_AUTO_REPORT,				//DD_AUTO_REPORT
	DD_CONFIG_ITEM_NETWORK_PLATFORM,//ƽ̨ip
	DD_CONFIG_ITEM_NETWORK_END,

	DD_CONFIG_ITEM_ACCOUNT_BASE=0x0700,
	DD_CONFIG_ITEM_ACCOUNT,					//DD_ACCOUNT_CONFIG * MAX_USER_NUM
	DD_CONFIG_ITEM_ACCOUNT_END,

	DD_CONFIG_ITEM_SENSOR_BASE=0x0800,
	DD_CONFIG_ITEM_SENSOR_SETUP,			//DD_SENSOR_CONFIG * SENSOR_INPUT_NUM
	DD_CONFIG_ITEM_SENSOR_SCHEDULE,			//DD_WEEK_SCHEDULE * SENSOR_INPUT_NUM
	DD_CONFIG_ITEM_SENSOR_ALARM_OUT,		//DD_TRIGGER_ALARM_OUT * SENSOR_INPUT_NUM
	DD_CONFIG_ITEM_SENSOR_TO_RECORD,		//DD_TRIGGER_RECORD * SENSOR_INPUT_NUM
	DD_CONFIG_ITEM_SENSOR_TO_PTZ,			//(DD_TRIGGER_PTZ * VIDEO_INPUT_NUM) * SENSOR_INPUT_NUM
	DD_CONFIG_ITEM_SENSOR_END,

	DD_CONFIG_ITEM_MOTION_BASE=0x0900,
	DD_CONFIG_ITEM_MOTION_SETUP,			//DD_MOTION_CONFIG * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_MOTION_SCHEDULE,			//DD_WEEK_SCHEDULE * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_MOTION_ALARM_OUT,		//DD_TRIGGER_ALARM_OUT * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_MOTION_TO_RECORD,		//DD_TRIGGER_RECORD * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_MOTION_TO_PTZ,			//(DD_TRIGGER_PTZ * VIDEO_INPUT_NUM) * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_MOTION_END,

	DD_CONFIG_ITEM_SHELTER_BASE=0x0a00,
	DD_CONFIG_ITEM_SHELTER_SETUP,			//DD_MOTION_CONFIG * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_SHELTER_SCHEDULE,		//DD_WEEK_SCHEDULE * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_SHELTER_ALARM_OUT,		//DD_TRIGGER_ALARM_OUT * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_SHELTER_TO_RECORD,		//DD_TRIGGER_RECORD * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_SHELTER_TO_PTZ,			//(DD_TRIGGER_PTZ * VIDEO_INPUT_NUM) * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_SHELTER_END,

	DD_CONFIG_ITEM_VLOSS_BASE=0x0b00,
	DD_CONFIG_ITEM_VLOSS_SCHEDULE,			//DD_WEEK_SCHEDULE * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_VLOSS_ALARM_OUT,			//DD_TRIGGER_ALARM_OUT * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_VLOSS_TO_RECORD,			//DD_TRIGGER_RECORD * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_VLOSS_TO_PTZ,			//(DD_TRIGGER_PTZ * VIDEO_INPUT_NUM) * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_VLOSS_END,

	DD_CONFIG_ITEM_ALARM_OUT_BASE=0x0c00,
	DD_CONFIG_ITEM_RELAY_SETUP,				//DD_RELAY_CONFIG * RELAY_NUM
	DD_CONFIG_ITEM_RELAY_SCHEDULE,			//DD_WEEK_SCHEDULE * RELAY_NUM
	DD_CONFIG_ITEM_BUZZER_SETUP,			//DD_BUZZER_CONFIG
	DD_CONFIG_ITEM_BUZZER_SCHEDULE,			//DD_WEEK_SCHEDULE
	DD_CONFIG_ITEM_ALARM_OUT_END,

	DD_CONFIG_ITEM_PTZ_BASE=0x0d00,
	DD_CONFIG_ITEM_PTZ_SETUP,				//DD_PTZ_CONFIG * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_PTZ_PRESET,				//DD_PTZ_PRESET_CONFIG * VIDEO_INPUT_NUM
	DD_CONFIG_ITEM_PTZ_PROTOCOL_INFO,       //DD_PTZ_PROTOCOL_INFO
	DD_CONFIG_ITEM_PTZ_END,

	DD_DECODER_CONFIG_ITEM_BASE=0x0e00,
	DD_DECODER_CONFIG_DEVICE_INFO,			//DEC_DEVICE_CONFIG
	DD_DECODER_CONFIG_NETWORK_INFO,			//DEC_NETWORK_CONFIG
	DD_DECODER_CONFIG_NTP_INFO,				//DEC_ADVANCE_NETWORK
	DD_DECODER_CONFIG_DDNS_INFO,			//DEC_DDNS_INFO
	DD_DECODER_CONFIG_SENSOR_SETUP,			//DEC_SENSOR_SETUP* VIDEO_INPUT_NUM
	DD_DECODER_CONFIG_SENSOR_SCHEDULE,		//DEC_WEEK_SCHEDULE * VIDEO_INPUT_NUM
	DD_DECODER_CONFIG_OTHER_ALARMOUT,		//DEC_OTHER_ALARM* VIDEO_INPUT_NUM

    DD_ITEM_ALARM_STATUS =0x0f00, //ǰ״̬N9000  DD_ALARM_STATUS_INFO * NUM

	DD_CONFIG_ITEM_SMART_BASE=0x1000,
	DD_CONFIG_ITEM_SMART_VFD, // DD_SMART_VFD_CONFIG * VIDEO_INPUT_NUM

	DD_CONFIG_ITEM_END
}DD_CONFIG_ITEM_ID;

///////////////////////////////////////


const unsigned int DEC_MAX_NAME_LEN = 64;
const unsigned int DEC_MAX_VERSION_BUF_LEN = 64;
const unsigned int DEC_MAX_BUF_LEN = (DEC_MAX_NAME_LEN * 2) + 4;

typedef struct _dec_device_config
{
	unsigned int	iSize;		//ṹ峤

	char			deviceName [DEC_MAX_NAME_LEN];			//豸ƣע⿼˫ַֽ
	unsigned int	channelNum;								//ͨ
	unsigned int	productID;								//ƷID
	unsigned int	productSubID;							//ƷID
	//Ϊֻ
	//version
	unsigned int	softVersion;							//汾
	char			mcuVersion [DEC_MAX_VERSION_BUF_LEN];			//MCU汾
	char			kernelVersion [DEC_MAX_VERSION_BUF_LEN];	//ں˰汾
	char			hardwareVersion [DEC_MAX_VERSION_BUF_LEN];	//Ӳ汾

}DEC_DEVICE_CONFIG;

typedef struct _dec_network_config
{	
	unsigned int	iSize;		//ṹ峤

	unsigned int	IP;				//ַ
	unsigned int	subnetMask;		//
	unsigned int	gateway;		//
	
	unsigned short httpPort;		//HTTP˿
	unsigned short decoderPort;			//˿
	char MAC [8];					//󶨵ַ
	unsigned int multiCastIP;		//ಥַ
	unsigned int bDHCP;

	unsigned int dns1;				//DNS1
	unsigned int dns2;				//DNS2
}DEC_NETWORK_CONFIG;

typedef struct _dec_advance_network
{
	unsigned int	iSize;		//ṹ峤

	unsigned char TimeZone; //ʱ
	unsigned char hour;
	unsigned char min;
	unsigned char sec;
	unsigned char mday;
	unsigned char month;
	unsigned short year;//2008~2025
	
	bool	enableFlag;		//NTPʹܱʶ
	char	name [132];			//NTPַ
	int		NTP_Port;			//NTPĶ˿
	int		syncInterval;		//ͬʱСʱΪλ
}DEC_ADVANCE_NETWORK;

typedef struct _dec_sensor_setup_
{
	unsigned int iSize;		//ṹ峤

	unsigned char	enable;		//Ƿ
	unsigned char	bNO;		//豸ͣ߳
	unsigned short	holdTime;	//ӳʱ

	char name [DEC_MAX_BUF_LEN];	//豸
	unsigned int  toBuzzer;			//
	unsigned int  toAlarmOut;			//λӦ豸
}DEC_SENSOR_SETUP;

typedef struct _dec_other_alarm_
{
	unsigned int iSize;					//ṹ峤

	unsigned int toBuzzerForIPConflict;	//IPͻ
	unsigned int toAlarmOutForDisconnect;	//IPͻλӦ豸
	unsigned int toBuzzerForDisconnect;	//Ͽ
	unsigned int toAlarmOutForIPConflict;	//ϿλӦ豸
}DEC_OTHER_ALARM;

//ų̽ṹ2424Сʱunsigned long longÿһλÿһӵ״̬
typedef struct _dec_date_schedule_
{
	unsigned long long hour [24];
}DEC_DATE_SCHEDULE;

//ų̽ṹ7ʾÿ7ų
typedef struct _dec_week_schedule_
{
	DEC_DATE_SCHEDULE week[7];
}DEC_WEEK_SCHEDULE;

#endif //__DVR_DVS_CONFIG_H__
